// ==UserScript==
// @name            Short URL Expander
// @description     Expand Short-URLs on Twitter ver.0.0.8_mod_002a (SeaHorse/Greasemonkey)
// @include         http://twitter.com/*
// @include         https://twitter.com/*
// @include         http://search.twitter.com/search*
// @include         https://search.twitter.com/search*
// @namespace       http://d.hateana.ne.jp/furyu-tei
// @version         0.0.8 OreSama (0.0.8_mod_001~: modified by @furyutei)
// @type            SleipnirScript
// ==/UserScript==
/************************************************
http://longurlplease.appspot.com/
Supporting 73 services

http://untiny.me/api/
Untiny supports 212 tiny services:
************************************************/

(function(arg) {

var	win = arg.win;
var	fenrir_client = arg.fenrir_client;
if (fenrir_client && typeof(win.execScript) != 'object') {
	fenrir_client.Output.Print('Short URL Expand in ATTS : window.execScript\u304c\u66f8\u304d\u63db\u3048\u3089\u308c\u3066\u3044\u308b\u53ef\u80fd\u6027\u304c\u3042\u308b\u305f\u3081\u3001\u51e6\u7406\u3092\u4e2d\u6b62\u3057\u307e\u3059', false);
	/*	'Short URL Expand in ATTS : window.execScriptが書き換えられている可能性があるため、処理を中止します'	*/
	return;
}

function core(w,d){
	var fenrir_client = window.fenrir_client;
	if (fenrir_client) {
		w = window; d = document;
		w.fenrir_client = null;
	}
	// === setings: start
	/*
	  [リンク文字置換用設定]
		TEXT_EXPAND		:	true=リンク文字を展開後の URL にする ／ false=リンク文字を置換しない
		MAX_LENGTH		:	リンク文字の最長文字数(リンク文字がこれより長い場合は省略)
							※3以上の整数が有効値、有効範囲外の場合は機能を無効化(省略なし)
		
	  [Short URLドメインリストキャッシュ用データベース設定]
		DB_NAME			:	データベース名
		UPDATE_TIME		:	キャッシュ有効期間（ms単位、例：3 * 24 * 3600 * 1000 → 3日×24時間/日×3600秒/時間×1000ms/秒)
		SITEINFO_URL	:	キャッシュ用データ取得URL
							※通常時：http://wedata.net/databases/ShortUrlServices/items.json にリダイレクト
							※wedataダウン時：キャッシュから読み出し
	*/
	var TEXT_EXPAND = false;
	var MAX_LENGTH  = 26;
	var	DB_NAME = 'ShortURLExpander';
	var	UPDATE_TIME = 3 * 24 * 3600 * 1000;
	var	SITEINFO_URL = 'http://furyutei.appspot.com/wedata?database=ShortUrlServices';
	// === settings: end
	
	var filterList = [];
	w.ShortURLExpander = {};
	w.ShortURLExpander.addFilter = function(func){
		filterList.push(func);
	};
	if (!fenrir_client) {
		var	ev = d.createEvent('Event');
		ev.initEvent('GM_ShortUrlExpander', true, false);
		document.dispatchEvent(ev)
	}
	var	support = null;
	
	var	get_reg_text = function(json) {
		var	infos = (typeof JSON!='undefined')?JSON.parse(json):eval('('+json+')');
		var	domains = [];
		for (var ci=0,leni=infos.length; ci<leni; ci++) domains[ci] = infos[ci].data.domain;
		return domains.join('|');
	};
	if (fenrir_client) {	//	SeaHorse (Sleipnir or Grani)
		var	XHRexec = function(opt) {
			var	url = opt.url.replace(/#.*$/,'');
			var	onload = (opt.onload)?opt.onload:function(){}, onerror = (opt.onerror)?opt.onerror:function(){};
			var xh = fenrir_client.CreateObject('MSXML2.ServerXMLHTTP');
			xh.open('GET', url, true);
			xh.onreadystatechange = function() {
				if (xh.readyState != 4) return;
				setTimeout(function(){((200<=xh.status&&xh.status<300)?onload:onerror)(xh)},1);
			};
			xh.send(null);
		};
		var	onload = (function(){
			var	db = fenrir_client.Database.Open(DB_NAME);
			db.Query("CREATE TABLE IF NOT EXISTS info (lastUpdate, support);");
			var res = db.Query('SELECT lastUpdate FROM info;');
			var	request = true;
			if (res.HasMore()) {
				var row = res.FetchArray();
				if (new Date().getTime() < row.At(0)+UPDATE_TIME) {
					var res = db.Query('SELECT support FROM info;');
					if (res.HasMore()) {
						var	txt_support = res.FetchArray().At(0);
						support = new RegExp(txt_support);
						request = false;
					}
				}
			}
			db = null;
			if (!request) return null;
			return function(xh) {
				var	txt_support = get_reg_text(xh.responseText);
				var db = fenrir_client.Database.Open(DB_NAME);
				db.Query("DROP TABLE IF EXISTS info;");
				db.Query("CREATE TABLE info (lastUpdate, support);");
				db.Query([
					"INSERT INTO info (lastUpdate, support) VALUES('"
				,	new Date().getTime()
				,	"','"
				,	txt_support.replace(/'/g,"''")
				,	"')"
				].join(''));
				support = new RegExp(txt_support);
				db = null;
			};
		})();
		var	link_css_selector = '.entry-content>a.web';
		var	link_css_selector_search = 'span.msgtxt>a';
	}
	else {	//	Greasemonkey (Firefox)
		var	XHRexec = function(opt) {
			var	url = opt.url.replace(/#.*$/,'');
			var	onload = (opt.onload)?opt.onload:function(){}, onerror = (opt.onerror)?opt.onerror:function(){};
			setTimeout(function(){
				GM_xmlhttpRequest({
					method	:	'GET'
				,	url		:	url
				,	onload	:	function(xh){setTimeout(function(){onload(xh)},1)}
				,	onerror	:	function(xh){setTimeout(function(){onerror(xh)},1)}
				});
			},1);
		};
		var	xpathGetElements=function(xpath,base,doc){
			var	hNodes=[];
			if (!doc||!doc.evaluate) doc=d;
			if (!base) base=doc;
			try {
				var nsnaps=doc.evaluate(xpath,base,null,XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,null);
				for (var ci=0,len=nsnaps.snapshotLength; ci<len; ci++) {
					hNodes[ci]=nsnaps.snapshotItem(ci);
				}
			} catch(e){}
			return hNodes;
		};
		var	onload = (function(){
			var	clear_cache=function(reload){
				GM_setValue(DB_NAME, '');
				alert('Short URL Expander \u306e\u30ad\u30e3\u30c3\u30b7\u30e5\u3092\u30af\u30ea\u30a2\u3057\u307e\u3057\u305f');	//	'Short URL Expander のキャッシュをクリアしました'
				if (reload) w.location.reload();
			};
			GM_registerMenuCommand('Short URL Expander - clear cache', function(){clear_cache(true)});
			var cacheinfo = null;
			json = GM_getValue(DB_NAME);
			if (json) cacheinfo = JSON.parse(json);
			if (!cacheinfo) cacheinfo = {datetime:0};
			if (new Date().getTime() < cacheinfo.datetime+UPDATE_TIME && cacheinfo.support) {
				support = new RegExp(cacheinfo.support);
				return null;
			}
			return function(xh) {
				var	txt_support = get_reg_text(xh.responseText);
				GM_setValue(DB_NAME, JSON.stringify({datetime:new Date().getTime(), support:txt_support}));
				support = new RegExp(txt_support);
			};
		})();
		var	link_xpath = '//*[contains(concat(" ",@class," ")," entry-content ")]/a[contains(concat(" ",@class," ")," web ")]';
		var	link_xpath_search = '//span[contains(concat(" ",@class," ")," msgtxt ")]/a';
	}
	if (onload) {
		XHRexec({
			url		:	SITEINFO_URL
		,	onload	:	onload
		,	onerror	:	function(xh){alert('could not load "'+SITEINFO_URL+'": '+xh.status)}
		});
	}
	
	function change(link,res){
		var oldURL = link.href;
		// var newURL = eval('(' + res + ')')[oldURL];		//	http://longurlplease.appspot.com/api/v1.1?q=(short_url)
		// var newURL = eval('(' + res + ')')["org_url"];	//	http://untiny.me/api/1.0/extract?url=(short_url)&format=json
		var newURL = ((typeof JSON!='undefined')?JSON.parse(res):eval('('+res+')'))['exp'];
		if(newURL)
			replace(link,newURL);
		else
			replace(link,link.href);
	};
	function replace(link,newURL){
		var oldURL = link.href;
		link.title = newURL;
		link.href  = newURL;
		
		if(TEXT_EXPAND){
			link.innerHTML = (MAX_LENGTH>3 && newURL.length > MAX_LENGTH) ? 
				[newURL.substr(0,MAX_LENGTH - 3), '...'].join('') : 
				link.innerHTML = newURL;
		}else{
			link.innerHTML = (MAX_LENGTH>3 && oldURL.length > MAX_LENGTH) ? 
				[oldURL.substr(0,MAX_LENGTH - 3), '...'].join('') : 
				link.innerHTML = oldURL;
		};
		
		if(filterList.length){
			var leng = filterList.length;
			for(var i=0;i<leng;i++){
				filterList[i](link,newURL,oldURL);
			};
		};
	};
	function sent(link){
		XHRexec({
			//url	:	'http://longurlplease.appspot.com/api/v1.1?q=' + encodeURIComponent(link.href)
			//url	:	'http://untiny.me/api/1.0/extract?url=' + encodeURIComponent(link.href)
			url		:	'http://ux.nu/hugeurl?format=json&url=' + encodeURIComponent(link.href)
		,	onload: function(xh){change(link,xh.responseText)}
		,	onerror: function(xh){replace(link,link.href)}
		});
	};
	
	function filter(links){
		for(var i=0;i<links.length;i++){
			if(!links[i].href) continue;
			if(support.test(links[i].href) ){
				sent(links[i]);
			}else{
				replace(links[i],links[i].href);
			};
		};
	};
	function addRefreshFilter(filter, i) {
		i = i || 4;
		if (w.AutoRefresh && w.AutoRefresh.addFilter) {
			w.AutoRefresh.addFilter(filter);
		} else if (i > 1) {
			var f = arguments.callee;
			setTimeout(function() {
				f(filter, i - 1);
			}, 1000);
		}
	};
	function refreshFilter(){
		setTimeout(function(){
			var exLinks = $('.entry-content>a.web').get();
			filter(exLinks);
		}, 0)
	};
	
	setTimeout(function(){
		if (!support) {
			setTimeout(arguments.callee,100);
			return;
		}
		var	_location = w.location.href;
		if( w.ATSS && w.ATSS.addFunction){
			w.ATSS.addFunction(function(node){
				var exLinks = YAHOO.util.Dom.getElementsByClassName('ExternalLink','a',node);
				filter(exLinks);
			});
		}
		else if (/^https?:\/\/(?:search\.)?twitter\.com/.test(_location)) {
			var	flg_search = /^https?:\/\/search/.test(_location);
			if (fenrir_client) {	//	SeaHorse (Sleipnir or Grani)
				//var	_css_selector = flg_search?link_css_selector_search:link_css_selector;
				//var exLinks = $(_css_selector,d).get();
				var	get_exLinks=(function(){
					if (flg_search) {
						return function(elm) {
							var	spans = elm.getElementsByTagName('span');
							var	exLinks = [];
							for (var ci=0,len=spans.length; ci<len; ci++) {
								var	span=spans[ci];
								if (/ msgtxt /.test(' '+span.className+' ')) {
									var	link=span.getElementsByTagName('a')[0];
									if (link) exLinks[exLinks.length]=link;
								}
							}
							return exLinks;
						};
					}
					else {
						return function(elm) {
							return $(link_css_selector,elm).get();
						};
					}
				})();
				var	exLinks = get_exLinks(d);
				filter(exLinks);
				if (w.AutoPagerize && w.AutoPagerize.addElementFilter) {
					w.AutoPagerize.addElementFilter(function(elms){
						var	exLinks=[];
						for (var ci=0,len=elms.length; ci<len; ci++) {
							exLinks = exLinks.concat(get_exLinks(elms[ci]));
						}
						filter(exLinks);
					});
				};
				addRefreshFilter(refreshFilter);
			}
			else {	//	Greasemonkey (Firefox)
				var	_xpath = flg_search?link_xpath_search:link_xpath;
				var exLinks = xpathGetElements(_xpath,d);
				filter(exLinks);
				var	addApFilter = function(){
					w.AutoPagerize.addFilter(function(elms){
						var exLinks = [];
						for (var ci=0,len=elms.length; ci<len; ci++) exLinks.concat(xpathGetElements('.'+_xpath,elms[ci]));
						filter(exLinks)
					});
				};
				if (w.AutoPagerize && w.AutoPagerize.addDocumentFilter) {
					addApFilter();
				}
				else {
					d.addEventListener('GM_AutoPagerizeLoaded',addApFilter,false);
				}
				d.addEventListener('DOMNodeInserted',function(evt){
					var	elm=evt.target;
					if (elm.nodeType!=1) return;
					var	exLinks = xpathGetElements('.'+_xpath,elm);
					filter(exLinks);
				},false);
			}
		};
	},0);
	
}	//	end of core()

if (fenrir_client) {	//	SeaHorse (Sleipnir or Grani)
	try {
		win.fenrir_client = fenrir_client;
		win.execScript(['(',core,')()'].join(''), 'JavaScript');
		win.fenrir_client = null;
	} catch(e) {}
}
else {	//	Greasemonkey (Firefox)
	core(window,document);
}

})(
(function(){
	var	win=(typeof _window!= 'undefined')?_window:window;
	var	fenrir_client=(function(){
		if (typeof sleipnir != 'undefined') return sleipnir;
		if (typeof grani != 'undefined') return grani;
		return null;
	})();
	return {win:win, fenrir_client:fenrir_client};
})()
);

// ■ end of file
