// ==UserScript==
// @name            Twitter Show Image Thumbnail
// @description     Show Thumbnails on Twitter ver 0.02a2 (SeaHorse/Greasemonkey)
// @include         http://twitter.com/*
// @include         https://twitter.com/*
// @include         http://search.twitter.com/search*
// @include         https://search.twitter.com/search*
// @namespace       http://d.hateana.ne.jp/furyu-tei
// @type            SleipnirScript
// ==/UserScript==
// original by @958      https://gist.github.com/156953/916877a4eb57c77b57ebe654028622db8eb80493
// modified by @10th543  http://sharedfile.jp/r/3kyDGF2lDpNMIcQN/
// modified by @furyutei http://furyu-tei.sakura.ne.jp/script/TwitterShowImageThumb_wedata.zip
//               diary : http://d.hatena.ne.jp/furyu-tei/
//               wedata: http://wedata.net/databases/UrlToThumbnail/items

(function(arg) {

var	win = arg.win;
var	fenrir_client = arg.fenrir_client;
if (fenrir_client && typeof(win.execScript) != 'object') {
	fenrir_client.Output.Print('Twitter Show Image Thumbnail: abnormal termination.', false);
	return;
}

function core(w,d) {
	var fenrir_client = window.fenrir_client;
	if (fenrir_client) {
		w = window; d = document;
		w.fenrir_client = null;
	}
	if (w.ShowImageThumbnail) return;
	w.ShowImageThumbnail = true;
	
	// Options: start
	var	SHOW_SERVICE_NAME = true;
	var	LINK_TARGET = '_blank';
	var	DB_NAME = 'TwitterShowImageThumb';
	var	UPDATE_TIME = 3 * 24 * 3600 * 1000;	//	3days*24hours/day*3600seconds/hour*1000msec/second
	var	SITEINFO_URL = 'http://furyutei.appspot.com/wedata?database=UrlToThumbnail';
		//	from wedata: http://wedata.net/databases/UrlToThumbnail/items.json
	var	USE_GLOBAL_INFO = true;
	// Options: end
	
	var	CARRIER_INFO = [	//	carrier-informations(local)
	//=========
	// samples 
	//=========
	//generic image
	//	{name:"image"
	//	,	url:"^(http[s]?://[^/]+/.+\\.(?:jpg|jpeg|gif|png|bmp|ico)(?:\\?.*)?)$"
	//	,	pic:"$1"
	//	,	regopt:"i"
	//	,	serv:""}
	//twitpic support
	//,	{name:"twitpic"
	//	,	url:"^http://twitpic.com/(\\w+)$"
	//	,	pic:"http://twitpic.com/show/thumb/$1"
	//	,	serv:"http://twitpic.com/"}
	];
	
	var	CARRIER_INFO_GLOBAL = null;	//	carrier-informations(global)
	
	(function(){
		if (!USE_GLOBAL_INFO) return;
		var	infos_to_carrier_info=function(infos){
			var	carrier_info = [];
			for (var ci=0,leni=infos.length; ci<leni; ci++) {
				var	data = infos[ci].data;
				carrier_info[ci]={
					name: infos[ci].name
				,	url: data.url
				,	pic: data.pic
				,	regopt: data.regopt
				,	serv: data.serv
				};
			}
			carrier_info.sort(function(a,b){return(b.url.length-a.url.length)});
			return carrier_info;
		};
		if (fenrir_client) {	//	SeaHorse (Sleipnir or Grani)
			var	db = fenrir_client.Database.Open(DB_NAME);
			db.Query("CREATE TABLE IF NOT EXISTS info (lastUpdate, json);");
			var res = db.Query('SELECT lastUpdate FROM info;');
			var	request = true;
			if (res.HasMore()) {
				var row = res.FetchArray();
				if ((new Date()).getTime() < row.At(0)+UPDATE_TIME) {
					var res = db.Query('SELECT json FROM info;');
					if (res.HasMore()) {
						var	json = res.FetchArray().At(0);
						var	infos = (typeof JSON!='undefined')?JSON.parse(json):eval('('+json+')');
						CARRIER_INFO_GLOBAL = infos_to_carrier_info(infos);
						CARRIER_INFO = CARRIER_INFO.concat(CARRIER_INFO_GLOBAL);
						request = false;
					}
				}
			}
			db = null;
			if (!request) return;
			var http = fenrir_client.CreateObject('MSXML2.ServerXMLHTTP');
			http.open('GET', SITEINFO_URL, true);
			http.onreadystatechange = function() {
				if (http.readyState != 4) return;
				if (http.status != 200) {
					alert('could not load "'+SITEINFO_URL_URL+'": '+xh.status);
					return;
				}
				var	json = http.responseText;
				var db = fenrir_client.Database.Open(DB_NAME);
				db.Query("DROP TABLE IF EXISTS info;");
				db.Query("CREATE TABLE info (lastUpdate, json);");
				db.Query([
					"INSERT INTO info (lastUpdate, json) VALUES('"
				,	(new Date()).getTime()
				,	"','"
				,	json.replace(/'/g,"''")
				,	"')"
				].join(''));
				var	infos = (typeof JSON!='undefined')?JSON.parse(json):eval('('+json+')');
				CARRIER_INFO_GLOBAL = infos_to_carrier_info(infos);
				CARRIER_INFO = CARRIER_INFO.concat(CARRIER_INFO_GLOBAL);
				db = null;
			};
			http.send(null);
		}
		else {	//	Greasemonkey (Firefox)
			var	onload = (function(){
				var	clear_cache=function(reload){
					GM_setValue(DB_NAME, '');
					alert('Twitter Show Image Thumbnail \u306e\u30ad\u30e3\u30c3\u30b7\u30e5\u3092\u30af\u30ea\u30a2\u3057\u307e\u3057\u305f');	//	'Twitter Show Image Thumbnail のキャッシュをクリアしました'
					if (reload) w.location.reload();
				};
				GM_registerMenuCommand('Twitter Show Image Thumbnail - clear cache', function(){clear_cache(true)});
				var cacheinfo = null;
				json = GM_getValue(DB_NAME);
				if (json) cacheinfo = JSON.parse(json);
				if (!cacheinfo) cacheinfo = {datetime:0};
				if (new Date().getTime() < cacheinfo.datetime+UPDATE_TIME && cacheinfo.carrier_info) {
					CARRIER_INFO_GLOBAL = cacheinfo.carrier_info;
					CARRIER_INFO = CARRIER_INFO.concat(CARRIER_INFO_GLOBAL);
					return null;
				}
				return function(xh) {
					var	infos = JSON.parse(xh.responseText);
					CARRIER_INFO_GLOBAL = infos_to_carrier_info(infos);
					CARRIER_INFO = CARRIER_INFO.concat(CARRIER_INFO_GLOBAL);
					GM_setValue(DB_NAME, JSON.stringify({datetime:new Date().getTime(), carrier_info:CARRIER_INFO_GLOBAL}));
				};
			})();
			if (onload) {
				GM_xmlhttpRequest({
					method	:	'GET'
				,	url		:	SITEINFO_URL
				,	onload	:	onload
				,	onerror	:	function(xh){alert('could not load "'+SITEINFO_URL_URL+'": '+xh.status)}
				});
			}
		}
	})();
	
	function showThumb(elm) {
		if (USE_GLOBAL_INFO && !CARRIER_INFO_GLOBAL) {
			setTimeout(function(){
				showThumb(elm);
			},100);
			return;
		}
		var links;
		if (elm.tagName == 'A') {
			if ((' '+elm.className+' ').match(/ twitpic_thumb_link /)) return;
			links = [elm];
		} 
		else {
			links = (function(elm) {
				var src_links = elm.getElementsByTagName('a');
				var tgt_links = [];
				for (var ci=0,len=src_links.length; ci<len; ci++) {
					if ((' '+src_links[ci].className+' ').match(/ twitpic_thumb_link /)) continue;
					tgt_links[tgt_links.length]=src_links[ci];
				}
				return tgt_links;
			})(elm);
		}
		for (var ci=0,len=links.length; ci<len; ci++) {
			twitpic_thumb(links[ci]);
		}
	}

	// base on pbtweet http://web.me.com/t_trace/pbtweet.html
	function twitpic_thumb(link) {
		if (!link || 'unknown' == typeof(link.href) || !link.href) return;
		var	class_name = ' '+link.className+' ';
		if (class_name.match(/ show_image_thumb /)) return;
		if (!class_name.match(/ web /) && !(' '+link.parentNode.className+' ').match(/ msgtxt /)) return;
		
		var href = link.href;
		var pic_thumb_src = '';
		
		var matched_info = null;
		for (var ci=0,leni=CARRIER_INFO.length; ci<leni; ci++) {
			var	cinfo = CARRIER_INFO[ci], reg = new RegExp(cinfo.url, (cinfo.regopt)?cinfo.regopt:''), _m = href.match(reg);
			if (!_m || _m.length<2) continue;
			pic_thumb_src = cinfo.pic;
			for (var cj=1,lenj=_m.length; cj<lenj; cj++) pic_thumb_src = pic_thumb_src.replace(RegExp('\\$'+cj,'g'), _m[cj])
			matched_info = cinfo;
			break;
		}
		
		if (pic_thumb_src != '') {
			place_picture(link, pic_thumb_src, href, matched_info);	//	( <-- place_picture(link.parentNode, pic_thumb_src, href) )
			link.className += ' show_image_thumb';
		}
	}
	
	function place_picture(link, src, org, matched_info)	//	( <-- place_picture(elm, src, org) )
	{
		var pic_container = d.createElement('div');
		var pic_thumb = d.createElement('img');
		var pic_thumb_link = d.createElement('a');
		var pic_thumb_br = d.createElement('br');
		pic_thumb_link.href = org;
		if (LINK_TARGET) pic_thumb_link.target = LINK_TARGET;
		pic_container.className = 'twitpic_thumb';
		pic_thumb.src = src;
		pic_thumb_link.appendChild(pic_thumb);
		pic_thumb_link.className = 'twitpic_thumb_link'
		pic_container.appendChild(pic_thumb_link);
		pic_container.appendChild(pic_thumb_br);
		
		if (SHOW_SERVICE_NAME) {
			var pic_service_name = d.createElement('p');
			pic_service_name.appendChild(d.createTextNode(matched_info.name));
			if (matched_info.serv) {
				var	pic_service_link = d.createElement('a');
				pic_service_link.className = 'tsit_service';
				pic_service_link.href = matched_info.serv;
				if (LINK_TARGET) pic_service_link.target = LINK_TARGET;
				pic_service_link.appendChild(pic_service_name);
				pic_container.appendChild(pic_service_link);
			}
			else {
				pic_container.appendChild(pic_service_name);
			}
		}
		link.parentNode.insertBefore(pic_container, link.nextSibling);	// ( <-- elm.appendChild(pic_container) )
	}

	var	cssAddRule=(function(){
		var	styleElm=d.createElement('style');
		styleElm.type='text/css'
		try {d.getElementsByTagName('head')[0].appendChild(styleElm);}catch(e){}
		var	s=d.styleSheets[d.styleSheets.length-1];
		if (s.insertRule) {
			return function(selector, property){
				s.insertRule(selector+'{'+property+'}',s.cssRules.length);
			};
		}
		else {
			return function(selector, property){
				//s.addRule(selector,'{'+property+'}');
				s.addRule(selector,property);
			};
		}
	})();
	
	var isTwitter = true;
	if (/sleipnirstart\.com/.test(location.href)) {
		isTwitter = false;
	}
	
	cssAddRule('.twitpic_thumb', 'display:block!important; padding:5px; background:transparent;');
	if (!isTwitter) cssAddRule('.twitpic_thumb', 'position:absolute; right:0; z-index:999; margin-top:-2em;');
	if (fenrir_client) {
		cssAddRule('.twitpic_thumb', 'filter:DropShadow(color=silver);');
		cssAddRule('.twitpic_thumb a.twitpic_thumb_link', 'border:1px solid gray; padding:0; margin:0; background-color:white;');
		cssAddRule('.twitpic_thumb img', 'border:3px solid white; max-width:48px; width:auto;height:auto; padding:0;margin:0;');
		cssAddRule('.twitpic_thumb a:hover img', 'border:7px solid white; max-width:380px; width:auto; height:auto;');
	}
	else {
		cssAddRule('.twitpic_thumb a.twitpic_thumb_link', 'float:left; padding:0; margin:0; background-color:#cccccc;');
		cssAddRule('.twitpic_thumb img', 'position:relative; left:-3px; top:-3px; margin:0; padding:3px; background: white; border: solid 1px gray; max-width:48px; width:auto; height:auto;');
		cssAddRule('.twitpic_thumb a:hover img', 'position:relative; left:-7px; top:-7px; margin:0; padding: 7px; border:1px solid gray; max-width:380px; width:auto; height:auto;');
	}
	cssAddRule('.twitpic_thumb br', 'clear:both;');
	cssAddRule('.twitpic_thumb a.tsit_service', 'text-decoration: none!important; border: none!important; background-color:white;');
	cssAddRule('.twitpic_thumb a.tsit_service p', 'color:navy; margin:0 0 0 0!important; padding:4px 0 0 4px!important; font-size: small!important;');
	
	var	addSueFilter=function(){
		w.ShortURLExpander.addFilter(function(elm,href,org){
			if (href!=org) showThumb(elm);
		});
	};
	if (w.ShortURLExpander) {
		addSueFilter();
	}
	else if (!fenrir_client) {
		d.addEventListener('GM_ShortUrlExpander',addSueFilter,false);
	}
	var	addApFilter = function(){
		(w.AutoPagerize.addElementFilter||w.AutoPagerize.addFilter)(function(elms){
			for (var ci=0,len=elms.length; ci<len; ci++) showThumb(elms[ci]);
		});
	};
	if (w.AutoPagerize) {
		addApFilter();
	}
	else if (!fenrir_client) {
		d.addEventListener('GM_AutoPagerizeLoaded',addApFilter,false);
	}
	if (w.ATTS) {
		w.ATSS.addFunction(function(elm){
			showThumb(elm);
		});
	}
	if (isTwitter) {
		showThumb(d.body);
		if (fenrir_client) {
			if (/^https?:\/\/(?:search\.)?twitter\.com/.test(w.location.href)) {
				//	TO DO
			}
			else {
				var	updateScreen=function(url){
					setTimeout(function(){
						var	cnt=0;
						$('.hentry').each(
							function(){
								showThumb(this);
								if ((' '+this.className+' ').match(/ last-on-refresh /)) return false;
							}
						);
					},10);
				};
				var	org_updateTimeAgo=w.updateTimeAgo;
				w.updateTimeAgo=function(){
					org_updateTimeAgo();
					updateScreen();
				};
			}
		}
		else {
			d.addEventListener('DOMNodeInserted',function(evt){
				var	elm=evt.target;
				if (elm.nodeType!=1) return;
				showThumb(elm);
			},false);
		}
	}
	
}	//	end of core()

if (fenrir_client) {	//	SeaHorse (Sleipnir or Grani)
	try {
		win.fenrir_client = fenrir_client;
		win.execScript(['(',core,')()'].join(''), 'JavaScript');
		win.fenrir_client = null;
	} catch(e) {}
}
else {	//	Greasemonkey (Firefox)
	core(window,document);
}

})(
(function(){
	var	win=(typeof _window!= 'undefined')?_window:window;
	var	fenrir_client=(function(){
		if (typeof sleipnir != 'undefined') return sleipnir;
		if (typeof grani != 'undefined') return grani;
		return null;
	})();
	return {win:win, fenrir_client:fenrir_client};
})()
);

// ■ end of file
